// use creation workshop egeneric driver
// Note: this is rough unfinished code
// the servo code is for a shutter (for the projector) on a hobby type servo
// the serial stuff is for a serial based controller
// the accelstepper stuff is for a step/direction controller
// the uvled stuff is for turning a light source such as a uv led on and off through a relay or ssr
// adjust "PlatenStepsPerLayer" for layer thickness

#include <SoftwareSerial.h>

SoftwareSerial StepperDriveSerial(10, 11); // RX, TX

#include <Servo.h> 

Servo servo;  

int servoPin = 9;

#include <AccelStepper.h>

int motorSpeed = 9600; //maximum steps per second (about 3rps / at 16 microsteps)
int motorAccel = 80000; //steps/second/second to accelerate

int motorDirPin = 2; //digital pin 2
int motorStepPin = 3; //digital pin 3
int motorEnablePin = 4; //enable, can be ignored if no enable input on driver
//set up the accelStepper intance, the "1" tells it we are using a driver
AccelStepper stepper(1, motorStepPin, motorDirPin); 

#define SDATABUFFERSIZE 200
char sdataBuffer[SDATABUFFERSIZE+1]; //Add 1 for NULL terminator
byte sdataBufferIndex = 0;
boolean sstoreString = false; //This will be our flag to put the data in our buffer

#define xtop_limit 6
#define xbot_limit 7
#define signal_led 13
#define UVLED 12

int shutterclosed = 45;
int shutteropen = 0;

int UVLED_OFF = LOW; // off
int UVLED_ON = HIGH; // on

int PlatenStepsPerMillimeterMove = 640; // adjust

float LayerThickness;
String LayerThickness_String;
char buf[10];

boolean CycleLayer = false;
boolean Shutter = false;
boolean on_top_limit = false;
boolean on_bottom_limit = false;
unsigned long LayerCycleTimer = 0;
unsigned long ShutterTimer = 0;
int PlatenStepsPerLayer = 63; // steps needed for layer thickness (0.05000625 mm) was 64

int StepsToRaiseLowerVat = 3600;
unsigned long CurrentLayerPosition = 0;

char startChar = '@'; //
char CmdChar = ';';
char gcodeCmdChar = 'G';
char endChar = '\r';


void setup()
	{
    // init pc serial
    Serial.begin(115200);
//    Serial.begin(9600);
    Serial.flush();
    
//    Serial.println();            //warm up the serial port

// serial controller *****************************************************    
    StepperDriveSerial.begin(9600);
    StepperDriveSerial.print("X2W"); // half power to z axis at all times
    StepperDriveSerial.print("X2500RY2500R"); // 2500 steps per second lift, 2500 sps tilt
    StepperDriveSerial.print("Y500P"); // y slope
//************************************************************************
    
// step/dir controller ***************************************************
    stepper.setMaxSpeed(motorSpeed);
    stepper.setSpeed(motorSpeed);
    stepper.setAcceleration(motorAccel);
    
    pinMode(motorEnablePin, OUTPUT);
    digitalWrite(motorEnablePin, LOW); // enable controller (if controller has enable connect it to pin 4), set ot low or high or ignore depending on controller
    
    // stepper.moveTo(32000); // test, move 32000 steps
//************************************************************************

    servo.attach(servoPin);

  // init the uv led to off
    pinMode(UVLED, OUTPUT);
    digitalWrite(UVLED, UVLED_OFF);
 
	pinMode(signal_led,OUTPUT);
	digitalWrite(signal_led,LOW);
 
	pinMode(xtop_limit,INPUT);
	digitalWrite(xtop_limit,HIGH);
	pinMode(xbot_limit,INPUT);
	digitalWrite(xbot_limit,HIGH);

	servo.write(shutterclosed); // close shutter
	}
	
void loop()
  {
//    Serial.println(freeRam());
// need a comm timeout and bad data/invalid data trap
      
      stepper.run(); // for step/dir controllers
      
      
      while(Serial.available()>0) // messages
		{
          char sincomingbyte = Serial.read();
          
          if(sincomingbyte==startChar)
			{
                          //Serial.print(String(sdataBuffer));
              sdataBufferIndex = 0;  //initialize the dataBufferIndex
              sstoreString = true;
			}
          if(sstoreString)
			{
              //Let's check our index here, and abort if we're outside our buffer size
              if(sdataBufferIndex==SDATABUFFERSIZE){
                  // index is pointing to an array element outside our buffer. re init the buffer and bail
                  sdataBufferIndex = 0;
                  break;
              }
              if(sincomingbyte==endChar)
				{
				  //Our data string is complete.  Parse it here
				  Serial.println("ok"); //acknowlege the command
                                  Serial.println(String(sdataBuffer).substring(1,21));
				  
				  if (String(sdataBuffer).substring(1,21) == "UVLED-ON############") // only needed if using uv led
					{
					  digitalWrite(UVLED, UVLED_ON);
					  //Serial.println("ok");
					}
				  else if (String(sdataBuffer).substring(1,21) == "UVLED-OFF-TILT-VAT##") // 
					{
					  
					  LayerCycleTimer = millis(); // start timer for layer cycle
					  CycleLayer = true; // begin cycling vat and platen

					  Shutter = true; // shutter closed flag
					  ShutterTimer = millis();
					  servo.write(shutterclosed); // close shutter
					  
					  digitalWrite(UVLED, UVLED_OFF); // only needed if using uv led
					  
					  StepperDriveSerial.print("Y500PY1200G"); // tilt the vat
                                          delay(1000);
					  StepperDriveSerial.print("X500PX" + String(1600 + CurrentLayerPosition) + "G"); // raise the platen
	  
                                          // step/dir controller *****************************************
                                          stepper.moveTo(1600 + CurrentLayerPosition); 
                                          // *************************************************************

					  //Serial.println("ok");
					}
                                  else if (String(sdataBuffer).substring(1,21) == "INIT################") // reset position, open shutter
                                        {
                                          CurrentLayerPosition = 0;
                                          servo.write(shutteropen); // open shutter
			                  Shutter == false;
                                        }
                                  else if (String(sdataBuffer).substring(1,21) == "END#################") // reset position, open shutter
                                        {
                                          CurrentLayerPosition = 0;
                                          servo.write(shutterclosed); // close shutter
			                  Shutter == false; // keep it closed
                                        }

					  sstoreString = false;
					  //gpsread = true; //set flag for rc pwm routine
				}
              else
				{
                  sdataBuffer[sdataBufferIndex++] = sincomingbyte;
                  sdataBuffer[sdataBufferIndex] = 0; //null terminate the C string
				}
			}
		}
		
      while(StepperDriveSerial.available()>0) // messages from stepper
        {
          char stepperincomingbyte = StepperDriveSerial.read();
//          Serial.println(stepperincomingbyte);
        }


		if (digitalRead(xtop_limit) == LOW and on_top_limit == false) // hit limit
		  {
			on_top_limit = true;
			digitalWrite(signal_led,HIGH);
			StepperDriveSerial.print("Xz"); // stop
		  }

		if (digitalRead(xtop_limit) == HIGH and on_top_limit == true) // off limit
		  {
			on_top_limit = false;
			digitalWrite(signal_led,LOW);
		  }


		if (digitalRead(xbot_limit) == LOW and on_bottom_limit == false) // hit limit
		  {
			on_bottom_limit = true;
			digitalWrite(signal_led,HIGH);
			StepperDriveSerial.print("Xz"); // stop
		  }

		if (digitalRead(xbot_limit) == HIGH and on_bottom_limit == true) // off limit
		  {
			on_bottom_limit = false;
			digitalWrite(signal_led,LOW);
		  }



		if (CycleLayer == true)
		  {
			if (LayerCycleTimer + 3000 < millis()) // time to raise vat and lower platen
			  {
	//            Serial.println("un tilt vat");
				
				CurrentLayerPosition = CurrentLayerPosition + PlatenStepsPerLayer;
				StepperDriveSerial.print("X8000PX" + String(CurrentLayerPosition) + "GY2000PY0G"); // lower the platen, un-tilt the vat

                                // step/dir controller *****************************************
                                stepper.moveTo(CurrentLayerPosition); 
                                // *************************************************************
                                
				CycleLayer = false; // done cycling layer
			  }
		  }

		  
		if (Shutter == true)
		  {
			if (ShutterTimer + 5250 < millis())
			 {
			   servo.write(shutteropen); // open shutter
			   Shutter == false;
			 } 
		  }		  
      }
